Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hibernate.type
Class ComponentType

    java.lang.Object
      org.hibernate.type.AbstractType
          org.hibernate.type.ComponentType

All Implemented Interfaces:
  Serializable, AbstractComponentType, Type

Direct Known Subclasses:
  EmbeddedComponentType

    public class ComponentType

extends AbstractType
implements AbstractComponentType

Handles "component" mappings

Author:
  Gavin King
See Also:
  Serialized Form

Field Summary
`protected int` | `propertySpan`
`protected EntityModeToTuplizerMapping` | `tuplizerMapping`

Constructor Summary
`ComponentType(ComponentMetamodel metamodel)`

Method Summary
`Object` | `assemble(Serializable object, SessionImplementor session, Object owner)` Reconstruct the object from its cached "disassembled" state.
`int` | `compare(Object x, Object y, EntityMode entityMode)` compare two instances of the type
`Object` | `deepCopy(Object component, EntityMode entityMode, SessionFactoryImplementor factory)` Return a deep copy of the persistent state, stopping at entities and at collections.
`Serializable` | `disassemble(Object value, SessionImplementor session, Object owner)` Return a cacheable "disassembled" representation of the object.
`Object` | `fromXMLNode(org.dom4j.Node xml, Mapping factory)` Parse the XML representation of an instance.
`CascadeStyle` | `getCascadeStyle(int i)`
`int` | `getColumnSpan(Mapping mapping)` How many columns are used to persist this type.
`FetchMode` | `getFetchMode(int i)`
`int` | `getHashCode(Object x, EntityMode entityMode)` Get a hashcode, consistent with persistence "equality"
`int` | `getHashCode(Object x, EntityMode entityMode, SessionFactoryImplementor factory)` Get a hashcode, consistent with persistence "equality"
`String` | `getName()` Returns the abbreviated name of the type.
`String[]` | `getPropertyNames()` Get the names of the component properties
`boolean[]` | `getPropertyNullability()` Optional operation
`Object` | `getPropertyValue(Object component, int i, EntityMode entityMode)`
`Object` | `getPropertyValue(Object component, int i, SessionImplementor session)`
`Object[]` | `getPropertyValues(Object component, EntityMode entityMode)` Optional operation
`Object[]` | `getPropertyValues(Object component, SessionImplementor session)` Get the values of the component properties of a component instance
`Class` | `getReturnedClass()` The class returned by `nullSafeGet()` methods.
`Type[]` | `getSubtypes()` Get the types of the component properties
`Object` | `hydrate(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Retrieve an instance of the mapped class, or the identifier of an entity or collection, from a JDBC resultset.
`Object` | `instantiate(EntityMode entityMode)` This method does not populate the component parent
`Object` | `instantiate(Object parent, SessionImplementor session)`
`boolean` | `isComponentType()` Is this type a component type.
`boolean` | `isDirty(Object x, Object y, boolean[] checkable, SessionImplementor session)` Should the parent be considered dirty, given both the old and current field or element value?
`boolean` | `isDirty(Object x, Object y, SessionImplementor session)` Should the parent be considered dirty, given both the old and current field or element value?
`boolean` | `isEmbedded()`
`boolean` | `isEqual(Object x, Object y, EntityMode entityMode)` Compare two instances of the class mapped by this type for persistence "equality" - equality of persistent state.
`boolean` | `isEqual(Object x, Object y, EntityMode entityMode, SessionFactoryImplementor factory)` Compare two instances of the class mapped by this type for persistence "equality" - equality of persistent state.
`boolean` | `isMethodOf(Method method)`
`boolean` | `isModified(Object old, Object current, boolean[] checkable, SessionImplementor session)` Has the parent object been modified, compared to the current database state?
`boolean` | `isMutable()` Are objects of this type mutable.
`boolean` | `isSame(Object x, Object y, EntityMode entityMode)` Compare two instances of the class mapped by this type for persistence "equality" - equality of persistent state - taking a shortcut for entity references.
`boolean` | `isXMLElement()`
`Object` | `nullSafeGet(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Retrieve an instance of the mapped class from a JDBC resultset.
`Object` | `nullSafeGet(ResultSet rs, String name, SessionImplementor session, Object owner)` Retrieve an instance of the mapped class from a JDBC resultset.
`void` | `nullSafeSet(PreparedStatement st, Object value, int begin, boolean[] settable, SessionImplementor session)` Write an instance of the mapped class to a prepared statement, ignoring some columns.
`void` | `nullSafeSet(PreparedStatement st, Object value, int begin, SessionImplementor session)` Write an instance of the mapped class to a prepared statement.
`Object` | `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` | `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache, ForeignKeyDirection foreignKeyDirection)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` | `resolve(Object value, SessionImplementor session, Object owner)` Map identifiers to entities or collections.
`Object` | `semiResolve(Object value, SessionImplementor session, Object owner)` Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.
`void` | `setPropertyValues(Object component, Object[] values, EntityMode entityMode)` Optional operation
`void` | `setToXMLNode(org.dom4j.Node node, Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in an XML element.
`int[]` | `sqlTypes(Mapping mapping)` Return the SQL type codes for the columns mapped by this type.
`boolean[]` | `toColumnNullness(Object value, Mapping mapping)` Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.
`String` | `toLoggableString(Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in a log file.

Methods inherited from class org.hibernate.type.AbstractType
`beforeAssemble, getSemiResolvedType, isAnyType, isAssociationType, isCollectionType, isEntityType, replaceNode`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.hibernate.type.Type
`beforeAssemble, getSemiResolvedType, isAnyType, isAssociationType, isCollectionType, isEntityType`

Field Detail

### propertySpan

    protected final int propertySpan

### tuplizerMapping

    protected final EntityModeToTuplizerMapping tuplizerMapping

Constructor Detail

### ComponentType

    public ComponentType(ComponentMetamodel metamodel)

Method Detail

### sqlTypes

    public int[] sqlTypes(Mapping mapping)
                   throws MappingException

  Description copied from interface: `Type`
  Return the SQL type codes for the columns mapped by this type. The codes are defined on `java.sql.Types`.

  Specified by:
    `sqlTypes` in interface `Type`
  Returns:
    the typecodes
  Throws:
    `MappingException`
  See Also:
    `Types`

### getColumnSpan

    public int getColumnSpan(Mapping mapping)
                      throws MappingException

  Description copied from interface: `Type`
  How many columns are used to persist this type.

  Specified by:
    `getColumnSpan` in interface `Type`
  Throws:
    `MappingException`

### isComponentType

    public final boolean isComponentType()

  Description copied from interface: `Type`
  Is this type a component type. If so, the implementation must be castable to `AbstractComponentType`. A component type may own collections or associations and hence must provide certain extra functionality.

  Specified by:
    `isComponentType` in interface `Type`
  Overrides:
    `isComponentType` in class `AbstractType`
  Returns:
    boolean
  See Also:
    `AbstractComponentType`

### getReturnedClass

    public Class getReturnedClass()

  Description copied from interface: `Type`
  The class returned by `nullSafeGet()` methods. This is used to establish the class of an array of this type.

  Specified by:
    `getReturnedClass` in interface `Type`
  Returns:
    Class

### isSame

    public boolean isSame(Object x,
                          Object y,
                          EntityMode entityMode)
                   throws HibernateException

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" - equality of persistent state - taking a shortcut for entity references.

  Specified by:
    `isSame` in interface `Type`
  Overrides:
    `isSame` in class `AbstractType`
  Returns:
    boolean
  Throws:
    `HibernateException`

### isEqual

    public boolean isEqual(Object x,
                           Object y,
                           EntityMode entityMode)
                    throws HibernateException

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" - equality of persistent state.

  Specified by:
    `isEqual` in interface `Type`
  Overrides:
    `isEqual` in class `AbstractType`
  Returns:
    boolean
  Throws:
    `HibernateException`

### isEqual

    public boolean isEqual(Object x,
                           Object y,
                           EntityMode entityMode,
                           SessionFactoryImplementor factory)
                    throws HibernateException

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" - equality of persistent state.

  Specified by:
    `isEqual` in interface `Type`
  Overrides:
    `isEqual` in class `AbstractType`
  Returns:
    boolean
  Throws:
    `HibernateException`

### compare

    public int compare(Object x,
                       Object y,
                       EntityMode entityMode)

  Description copied from interface: `Type`
  compare two instances of the type

  Specified by:
    `compare` in interface `Type`
  Overrides:
    `compare` in class `AbstractType`

### isMethodOf

    public boolean isMethodOf(Method method)

  Specified by:
    `isMethodOf` in interface `AbstractComponentType`

### getHashCode

    public int getHashCode(Object x,
                           EntityMode entityMode)

  Description copied from interface: `Type`
  Get a hashcode, consistent with persistence "equality"

  Specified by:
    `getHashCode` in interface `Type`
  Overrides:
    `getHashCode` in class `AbstractType`

### getHashCode

    public int getHashCode(Object x,
                           EntityMode entityMode,
                           SessionFactoryImplementor factory)

  Description copied from interface: `Type`
  Get a hashcode, consistent with persistence "equality"

  Specified by:
    `getHashCode` in interface `Type`
  Overrides:
    `getHashCode` in class `AbstractType`

### isDirty

    public boolean isDirty(Object x,
                           Object y,
                           SessionImplementor session)
                    throws HibernateException

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current field or element value?

  Specified by:
    `isDirty` in interface `Type`
  Overrides:
    `isDirty` in class `AbstractType`
  Parameters:
    `x` - the old value
    `y` - the current value
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException`

### isDirty

    public boolean isDirty(Object x,
                           Object y,
                           boolean[] checkable,
                           SessionImplementor session)
                    throws HibernateException

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current field or element value?

  Specified by:
    `isDirty` in interface `Type`
  Parameters:
    `x` - the old value
    `y` - the current value
    `checkable` - which columns are actually updatable
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException`

### isModified

    public boolean isModified(Object old,
                              Object current,
                              boolean[] checkable,
                              SessionImplementor session)
                       throws HibernateException

  Description copied from interface: `Type`
  Has the parent object been modified, compared to the current database state?

  Specified by:
    `isModified` in interface `Type`
  Overrides:
    `isModified` in class `AbstractType`
  Parameters:
    `old` - the database state, in a "hydrated" form, with identifiers unresolved
    `current` - the current state of the object
    `checkable` - which columns are actually updatable
  Returns:
    true if the field has been modified
  Throws:
    `HibernateException`

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String[] names,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException,
                              SQLException

  Description copied from interface: `Type`
  Retrieve an instance of the mapped class from a JDBC resultset. Implementors should handle possibility of null values.

  Specified by:
    `nullSafeGet` in interface `Type`
    `names` - the column names
    `owner` - the parent entity
  Returns:
    Object
  Throws:
    `HibernateException`
    `SQLException`
  See Also:
    `alternative, 2-phase property initialization`

### nullSafeSet

    public void nullSafeSet(PreparedStatement st,
                            Object value,
                            int begin,
                            SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Description copied from interface: `Type`
  Write an instance of the mapped class to a prepared statement. Implementors should handle possibility of null values. A multi-column type should be written to parameters starting from `index`.

  Specified by:
    `nullSafeSet` in interface `Type`
    `value` - the object to write
    `begin` - statement parameter index
  Throws:
    `HibernateException`
    `SQLException`

### nullSafeSet

    public void nullSafeSet(PreparedStatement st,
                            Object value,
                            int begin,
                            boolean[] settable,
                            SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Description copied from interface: `Type`
  Write an instance of the mapped class to a prepared statement, ignoring some columns. Implementors should handle possibility of null values. A multi-column type should be written to parameters starting from `index`.

  Specified by:
    `nullSafeSet` in interface `Type`
    `value` - the object to write
    `begin` - statement parameter index
    `settable` - an array indicating which columns to ignore
  Throws:
    `HibernateException`
    `SQLException`

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String name,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException,
                              SQLException

  Description copied from interface: `Type`
  Retrieve an instance of the mapped class from a JDBC resultset. Implementations should handle possibility of null values. This method might be called if the type is known to be a single-column type.

  Specified by:
    `nullSafeGet` in interface `Type`
    `name` - the column name
    `owner` - the parent entity
  Returns:
    Object
  Throws:
    `HibernateException`
    `SQLException`

### getPropertyValue

    public Object getPropertyValue(Object component,
                                   int i,
                                   SessionImplementor session)
                            throws HibernateException

  Specified by:
    `getPropertyValue` in interface `AbstractComponentType`
  Throws:
    `HibernateException`

### getPropertyValue

    public Object getPropertyValue(Object component,
                                   int i,
                                   EntityMode entityMode)
                            throws HibernateException

  Throws:
    `HibernateException`

### getPropertyValues

    public Object[] getPropertyValues(Object component,
                                      SessionImplementor session)
                               throws HibernateException

  Description copied from interface: `AbstractComponentType`
  Get the values of the component properties of a component instance

  Specified by:
    `getPropertyValues` in interface `AbstractComponentType`
  Throws:
    `HibernateException`

### getPropertyValues

    public Object[] getPropertyValues(Object component,
                                      EntityMode entityMode)
                               throws HibernateException

  Description copied from interface: `AbstractComponentType`
  Optional operation

  Specified by:
    `getPropertyValues` in interface `AbstractComponentType`
  Throws:
    `HibernateException`

### setPropertyValues

    public void setPropertyValues(Object component,
                                  Object[] values,
                                  EntityMode entityMode)
                           throws HibernateException

  Description copied from interface: `AbstractComponentType`
  Optional operation

  Specified by:
    `setPropertyValues` in interface `AbstractComponentType`
  Throws:
    `HibernateException`

### getSubtypes

    public Type[] getSubtypes()

  Description copied from interface: `AbstractComponentType`
  Get the types of the component properties

  Specified by:
    `getSubtypes` in interface `AbstractComponentType`

### getName

    public String getName()

  Description copied from interface: `Type`
  Returns the abbreviated name of the type.

  Specified by:
    `getName` in interface `Type`
  Returns:
    String the Hibernate type name

### toLoggableString

    public String toLoggableString(Object value,
                                   SessionFactoryImplementor factory)
                            throws HibernateException

  Description copied from interface: `Type`
  A representation of the value to be embedded in a log file.

  Specified by:
    `toLoggableString` in interface `Type`
  Returns:
    String
  Throws:
    `HibernateException`

### getPropertyNames

    public String[] getPropertyNames()

  Description copied from interface: `AbstractComponentType`
  Get the names of the component properties

  Specified by:
    `getPropertyNames` in interface `AbstractComponentType`

### deepCopy

    public Object deepCopy(Object component,
                           EntityMode entityMode,
                           SessionFactoryImplementor factory)
                    throws HibernateException

  Description copied from interface: `Type`
  Return a deep copy of the persistent state, stopping at entities and at collections.

  Specified by:
    `deepCopy` in interface `Type`
  Parameters:
    `component` - generally a collection element or entity field
  Returns:
    Object a copy
  Throws:
    `HibernateException`

### replace

    public Object replace(Object original,
                          Object target,
                          SessionImplementor session,
                          Object owner,
                          Map copyCache)
                   throws HibernateException

  Description copied from interface: `Type`
  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Specified by:
    `replace` in interface `Type`
  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
  Returns:
    the value to be merged
  Throws:
    `HibernateException`

### replace

    public Object replace(Object original,
                          Object target,
                          SessionImplementor session,
                          Object owner,
                          Map copyCache,
                          ForeignKeyDirection foreignKeyDirection)
                   throws HibernateException

  Description copied from interface: `Type`
  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Specified by:
    `replace` in interface `Type`
  Overrides:
    `replace` in class `AbstractType`
  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
  Returns:
    the value to be merged
  Throws:
    `HibernateException`

### instantiate

    public Object instantiate(EntityMode entityMode)
                       throws HibernateException

  This method does not populate the component parent

  Throws:
    `HibernateException`

### instantiate

    public Object instantiate(Object parent,
                              SessionImplementor session)
                       throws HibernateException

  Throws:
    `HibernateException`

### getCascadeStyle

    public CascadeStyle getCascadeStyle(int i)

  Specified by:
    `getCascadeStyle` in interface `AbstractComponentType`

### isMutable

    public boolean isMutable()

  Description copied from interface: `Type`
  Are objects of this type mutable. (With respect to the referencing object ... entities and collections are considered immutable because they manage their own internal state.)

  Specified by:
    `isMutable` in interface `Type`
  Returns:
    boolean

### disassemble

    public Serializable disassemble(Object value,
                                    SessionImplementor session,
                                    Object owner)
                             throws HibernateException

  Description copied from interface: `Type`
  Return a cacheable "disassembled" representation of the object.

  Specified by:
    `disassemble` in interface `Type`
  Overrides:
    `disassemble` in class `AbstractType`
  Parameters:
    `value` - the value to cache
    `session` - the session
    `owner` - optional parent entity object (needed for collections)
  Returns:
    the disassembled, deep cloned state
  Throws:
    `HibernateException`

### assemble

    public Object assemble(Serializable object,
                           SessionImplementor session,
                           Object owner)
                    throws HibernateException

  Description copied from interface: `Type`
  Reconstruct the object from its cached "disassembled" state.

  Specified by:
    `assemble` in interface `Type`
  Overrides:
    `assemble` in class `AbstractType`
  Parameters:
    `object` - the disassembled state from the cache
    `session` - the session
    `owner` - the parent entity object
  Returns:
    the the object
  Throws:
    `HibernateException`

### getFetchMode

    public FetchMode getFetchMode(int i)

  Specified by:
    `getFetchMode` in interface `AbstractComponentType`

### hydrate

    public Object hydrate(ResultSet rs,
                          String[] names,
                          SessionImplementor session,
                          Object owner)
                   throws HibernateException,
                          SQLException

  Description copied from interface: `Type`
  Retrieve an instance of the mapped class, or the identifier of an entity or collection, from a JDBC resultset. This is useful for 2-phase property initialization - the second phase is a call to `resolveIdentifier()`.

  Specified by:
    `hydrate` in interface `Type`
  Overrides:
    `hydrate` in class `AbstractType`
    `names` - the column names
    `session` - the session
    `owner` - the parent entity
  Returns:
    Object an identifier or actual value
  Throws:
    `HibernateException`
    `SQLException`
  See Also:
    `Type.resolve(Object, SessionImplementor, Object)`

### resolve

    public Object resolve(Object value,
                          SessionImplementor session,
                          Object owner)
                   throws HibernateException

  Description copied from interface: `Type`
  Map identifiers to entities or collections. This is the second phase of 2-phase property initialization.

  Specified by:
    `resolve` in interface `Type`
  Overrides:
    `resolve` in class `AbstractType`
  Parameters:
    `value` - an identifier or value returned by `hydrate()`
    `session` - the session
    `owner` - the parent entity
  Returns:
    the given value, or the value associated with the identifier
  Throws:
    `HibernateException`
  See Also:
    `Type.hydrate(ResultSet, String[], SessionImplementor, Object)`

### semiResolve

    public Object semiResolve(Object value,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException

  Description copied from interface: `Type`
  Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.

  Specified by:
    `semiResolve` in interface `Type`
  Overrides:
    `semiResolve` in class `AbstractType`
  Throws:
    `HibernateException`

### getPropertyNullability

    public boolean[] getPropertyNullability()

  Description copied from interface: `AbstractComponentType`
  Optional operation

  Specified by:
    `getPropertyNullability` in interface `AbstractComponentType`
  Returns:
    nullability of component properties

### isXMLElement

    public boolean isXMLElement()

  Specified by:
    `isXMLElement` in interface `Type`
  Overrides:
    `isXMLElement` in class `AbstractType`

### fromXMLNode

    public Object fromXMLNode(org.dom4j.Node xml,
                              Mapping factory)
                       throws HibernateException

  Description copied from interface: `Type`
  Parse the XML representation of an instance.

  Specified by:
    `fromXMLNode` in interface `Type`
  Returns:
    an instance of the type
  Throws:
    `HibernateException`

### setToXMLNode

    public void setToXMLNode(org.dom4j.Node node,
                             Object value,
                             SessionFactoryImplementor factory)
                      throws HibernateException

  Description copied from interface: `Type`
  A representation of the value to be embedded in an XML element.

  Specified by:
    `setToXMLNode` in interface `Type`
  Throws:
    `HibernateException`

### toColumnNullness

    public boolean[] toColumnNullness(Object value,
                                      Mapping mapping)

  Description copied from interface: `Type`
  Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.

  Specified by:
    `toColumnNullness` in interface `Type`
  Parameters:
    `value` - an instance of the type

### isEmbedded

    public boolean isEmbedded()

  Specified by:
    `isEmbedded` in interface `AbstractComponentType`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD